'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMeasure = require('react-measure');

var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Pin = function (_Component) {
    _inherits(Pin, _Component);

    function Pin(props) {
        _classCallCheck(this, Pin);

        var _this = _possibleConstructorReturn(this, (Pin.__proto__ || Object.getPrototypeOf(Pin)).call(this, props));

        _this.onMouseDown = function (evt) {
            _this.props.onDrag(_this.props.pin, evt);
        };

        _this.onMouseUp = function (evt) {
            _this.props.onDrop(_this.props.pin, evt);
        };

        _this.measure = function (rect) {
            _this.props.onMeasure(rect.top, rect.height);
        };
        return _this;
    }

    _createClass(Pin, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            return this.props.pin !== nextProps.pin || this.props.shouldMeasure !== nextProps.shouldMeasure || this.props.onDrop !== nextProps.onDrop;
        }
    }, {
        key: 'render',
        value: function render() {
            var PinClass = this.props.pinClass;

            return _react2.default.createElement(
                _reactMeasure2.default,
                { whiteList: ['top', 'height'], shouldMeasure: this.props.shouldMeasure, onMeasure: this.measure },
                _react2.default.createElement(
                    'div',
                    { style: {
                            display: 'inline-block'
                        }, onMouseDown: this.onMouseDown, onMouseUp: this.onMouseUp },
                    _react2.default.createElement(PinClass, { pin: this.props.pin })
                )
            );
        }
    }]);

    return Pin;
}(_react.Component);

exports.default = Pin;