var ReactGraph =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.MenuState = exports.Edge = exports.Node = exports.Pin = exports.GraphState = exports.Graph = undefined;

	var _graph = __webpack_require__(11);

	var _graph2 = _interopRequireDefault(_graph);

	var _state = __webpack_require__(2);

	var _state2 = _interopRequireDefault(_state);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.Graph = _graph2.default;
	exports.GraphState = _state2.default;
	exports.Pin = _state.Pin;
	exports.Node = _state.Node;
	exports.Edge = _state.Edge;
	exports.MenuState = _state.MenuState;

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = React;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.MenuState = exports.Edge = exports.Node = exports.Pin = undefined;

	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _immutable = __webpack_require__(9);

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var defaultPin = {
	    name: '',
	    connected: false,
	    data: new _immutable.Map()
	};

	var Pin = exports.Pin = (0, _immutable.Record)(defaultPin);

	var defaultNode = {
	    id: 0,
	    title: '',
	    data: new _immutable.Map(),

	    x: 0,
	    y: 0,
	    width: 0,
	    height: 0,

	    minPin: 1 / 0,
	    pinHeight: 0,

	    inputs: new _immutable.List(),
	    outputs: new _immutable.List()
	};

	var Node = exports.Node = (0, _immutable.Record)(defaultNode);

	var defaultEdge = {
	    from: 0,
	    output: 0,
	    to: 0,
	    input: 0,
	    color: '#fff'
	};

	var Edge = exports.Edge = (0, _immutable.Record)(defaultEdge);

	var defaultEditorState = {
	    nodes: new _immutable.Map(),
	    edges: new _immutable.List(),
	    selection: new _immutable.List()
	};

	var EditorState = (0, _immutable.Record)(defaultEditorState);

	var defaultMouseState = {
	    down: false,
	    x: 0,
	    y: 0,
	    startX: 0,
	    startY: 0,

	    node: null,
	    pin: null
	};

	var MouseState = function (_Record) {
	    _inherits(MouseState, _Record);

	    function MouseState() {
	        _classCallCheck(this, MouseState);

	        return _possibleConstructorReturn(this, (MouseState.__proto__ || Object.getPrototypeOf(MouseState)).apply(this, arguments));
	    }

	    _createClass(MouseState, [{
	        key: 'draggingEdge',
	        get: function get() {
	            return this.node !== null && this.pin !== null;
	        }
	    }, {
	        key: 'rect',
	        get: function get() {
	            return {
	                minX: Math.min(this.startX, this.x),
	                minY: Math.min(this.startY, this.y),
	                maxX: Math.max(this.startX, this.x),
	                maxY: Math.max(this.startY, this.y)
	            };
	        }
	    }]);

	    return MouseState;
	}((0, _immutable.Record)(defaultMouseState));

	var defaultMenuState = {
	    open: false,
	    x: 0,
	    y: 0
	};

	var MenuState = exports.MenuState = (0, _immutable.Record)(defaultMenuState);

	var defaultGraphState = {
	    editorState: new EditorState(),

	    undoStack: new _immutable.Stack(),
	    redoStack: new _immutable.Stack(),

	    mouseState: new MouseState(),
	    menuState: new MenuState()
	};

	var GraphState = function (_Record2) {
	    _inherits(GraphState, _Record2);

	    function GraphState() {
	        _classCallCheck(this, GraphState);

	        return _possibleConstructorReturn(this, (GraphState.__proto__ || Object.getPrototypeOf(GraphState)).apply(this, arguments));
	    }

	    _createClass(GraphState, [{
	        key: 'save',
	        value: function save() {
	            return this.editorState.toJS();
	        }
	    }, {
	        key: 'addNode',
	        value: function addNode(node) {
	            var _menuState = this.menuState,
	                x = _menuState.x,
	                y = _menuState.y;


	            return this.__pushState(this.editorState.update('nodes', function (nodes) {
	                var data = new Node(_extends({}, node, {
	                    id: nodes.size,
	                    x: x,
	                    y: y
	                }));

	                return nodes.set(data.id, data);
	            }));
	        }
	    }, {
	        key: '_measureNode',
	        value: function _measureNode(id, width, height) {
	            return this.updateIn(['editorState', 'nodes', id], function (node) {
	                return node.set('width', width).set('height', height);
	            });
	        }
	    }, {
	        key: '_measurePin',
	        value: function _measurePin(id, y, height) {
	            return this.updateIn(['editorState', 'nodes', id], function (node) {
	                return node.update('minPin', function (v) {
	                    return Math.min(v, y - node.y);
	                }).set('pinHeight', height);
	            });
	        }
	    }, {
	        key: 'moveNode',
	        value: function moveNode(id, x, y) {
	            var _this3 = this;

	            var pushUndo = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

	            var nextState = this.isSelected(id) ? this.editorState.update('nodes', function (nodes) {
	                var node = nodes.get(id);
	                var deltaX = x - node.x;
	                var deltaY = y - node.y;

	                return nodes.map(function (n) {
	                    if (_this3.isSelected(n.id)) {
	                        return n.set('x', n.x + deltaX).set('y', n.y + deltaY);
	                    }

	                    return n;
	                });
	            }) : this.editorState.set('selection', new _immutable.List([id])).updateIn(['nodes', id], function (node) {
	                return node.set('x', x).set('y', y);
	            });

	            if (pushUndo) {
	                return this.__pushState(nextState);
	            }

	            return this.set('editorState', nextState);
	        }
	    }, {
	        key: 'mapNodes',
	        value: function mapNodes(fn) {
	            return this.updateIn(['editorState', 'nodes'], function (nodes) {
	                return nodes.map(fn);
	            });
	        }
	    }, {
	        key: '_startConnection',
	        value: function _startConnection(node, pin) {
	            return this.update('mouseState', function (mouse) {
	                return mouse.set('node', node.id).set('pin', node.outputs.findKey(function (_ref) {
	                    var name = _ref.name;
	                    return name === pin.name;
	                }));
	            });
	        }
	    }, {
	        key: '_endConnection',
	        value: function _endConnection(node, pin) {
	            var from = this.mouseState.node;
	            var output = this.mouseState.pin;

	            var to = node.id;
	            var input = node.inputs.findKey(function (_ref2) {
	                var name = _ref2.name;
	                return name === pin.name;
	            });

	            return this._endMouse().addLink(from, output, to, input);
	        }
	    }, {
	        key: 'addLink',
	        value: function addLink(from, output, to, input) {
	            return this.__pushState(this.editorState.update('nodes', function (nodes) {
	                return nodes.updateIn([from, 'outputs', output], function (pin) {
	                    return pin.set('connected', true);
	                }).updateIn([to, 'inputs', input], function (pin) {
	                    return pin.set('connected', true);
	                });
	            }).update('edges', function (edges) {
	                return edges.filter(function (edge) {
	                    return edge.to !== to || edge.input !== input;
	                }).push(new Edge({
	                    id: edges.size,
	                    from: from,
	                    to: to,
	                    output: output,
	                    input: input
	                }));
	            }));
	        }
	    }, {
	        key: 'openMenu',
	        value: function openMenu(x, y) {
	            return this.update('menuState', function (menu) {
	                return menu.set('open', true).set('x', x).set('y', y);
	            });
	        }
	    }, {
	        key: 'closeMenu',
	        value: function closeMenu() {
	            return this.setIn(['menuState', 'open'], false);
	        }
	    }, {
	        key: 'selectNode',
	        value: function selectNode(id) {
	            var pushNode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

	            return this.__pushState(this.editorState.update('selection', function (selection) {
	                if (pushNode) {
	                    return selection.push(id);
	                }

	                return new _immutable.List([id]);
	            }));
	        }
	    }, {
	        key: 'isSelected',
	        value: function isSelected(node) {
	            return this.editorState.selection.find(function (id) {
	                return id === node;
	            }) !== undefined;
	        }
	    }, {
	        key: 'clearSelection',
	        value: function clearSelection() {
	            return this.editorState.selection.isEmpty() ? this : this.__pushState(this.editorState.update('selection', function (list) {
	                return list.clear();
	            }));
	        }
	    }, {
	        key: '_startMouse',
	        value: function _startMouse(x, y) {
	            return this.update('mouseState', function (mouse) {
	                return mouse.set('down', true).set('startX', x).set('startY', y);
	            })._updateMouse(x, y);
	        }
	    }, {
	        key: '_updateMouse',
	        value: function _updateMouse(x, y) {
	            var nextState = this.update('mouseState', function (mouse) {
	                return mouse.set('x', x).set('y', y);
	            });

	            var _nextState$mouseState = nextState.mouseState,
	                node = _nextState$mouseState.node,
	                pin = _nextState$mouseState.pin;


	            if (node == null && pin == null) {
	                var _ret = function () {
	                    var _nextState$mouseState2 = nextState.mouseState.rect,
	                        minX = _nextState$mouseState2.minX,
	                        minY = _nextState$mouseState2.minY,
	                        maxX = _nextState$mouseState2.maxX,
	                        maxY = _nextState$mouseState2.maxY;


	                    return {
	                        v: nextState.setIn(['editorState', 'selection'], nextState.editorState.nodes.filter(function (n) {
	                            return n.x >= minX && n.x + n.width <= maxX && n.y >= minY && n.y + n.height <= maxY;
	                        }).map(function (_ref3) {
	                            var id = _ref3.id;
	                            return id;
	                        }))
	                    };
	                }();

	                if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
	            }

	            return nextState;
	        }
	    }, {
	        key: '_endMouse',
	        value: function _endMouse() {
	            var nextState = this;
	            if (!this.mouseState.draggingEdge) {
	                nextState = this.__pushState(this.editorState);
	            }

	            return nextState.update('mouseState', function (mouse) {
	                return mouse.set('down', false).set('node', null).set('pin', null);
	            });
	        }
	    }, {
	        key: '__pushState',
	        value: function __pushState(nextState) {
	            var _this4 = this;

	            return this.update('undoStack', function (stack) {
	                return stack.push(_this4.editorState);
	            }).set('editorState', nextState);
	        }
	    }, {
	        key: 'undo',
	        value: function undo() {
	            if (this.undoStack.isEmpty()) {
	                return this;
	            }

	            var prevState = this.undoStack.peek();
	            var currState = this.editorState;

	            return this.set('editorState', prevState).update('undoStack', function (stack) {
	                return stack.pop();
	            }).update('redoStack', function (stack) {
	                return stack.push(currState);
	            });
	        }
	    }, {
	        key: 'redo',
	        value: function redo() {
	            if (this.redoStack.isEmpty()) {
	                return this;
	            }

	            var currState = this.editorState;
	            var nextState = this.redoStack.peek();

	            return this.set('editorState', nextState).update('undoStack', function (stack) {
	                return stack.push(currState);
	            }).update('redoStack', function (stack) {
	                return stack.pop();
	            });
	        }
	    }, {
	        key: 'selectedNodes',
	        get: function get() {
	            var _this5 = this;

	            return this.editorState.selection.map(function (id) {
	                return _this5.editorState.nodes.get(id);
	            });
	        }
	    }], [{
	        key: 'createEmpty',
	        value: function createEmpty() {
	            return new GraphState();
	        }
	    }, {
	        key: 'fromGraph',
	        value: function fromGraph(nodes, edges) {
	            return new GraphState({
	                editorState: new EditorState({
	                    nodes: nodes, edges: edges
	                })
	            });
	        }
	    }, {
	        key: 'restore',
	        value: function restore(data) {
	            return new GraphState({
	                editorState: (0, _immutable.fromJS)(data, function (key, value) {
	                    switch (key) {
	                        case '':
	                            return new EditorState(value.toObject());

	                        case 'selection':
	                            return value.toList();

	                        case 'nodes':
	                            return value.toMap().mapEntries(function (_ref4) {
	                                var _ref5 = _slicedToArray(_ref4, 2),
	                                    k = _ref5[0],
	                                    v = _ref5[1];

	                                return [Number(k), new Node(v.toObject())];
	                            });

	                        case 'edges':
	                            return value.toList().map(function (edge) {
	                                return new Edge(edge.toObject());
	                            });

	                        case 'inputs':
	                        case 'outputs':
	                            return value.toList().map(function (pin) {
	                                return new Pin(pin);
	                            });

	                        case 'data':
	                            return value.toMap();

	                        default:
	                            {
	                                var isIndexed = _immutable.Iterable.isIndexed(value);
	                                return isIndexed ? value.toList() : value.toMap();
	                            }
	                    }
	                })
	            });
	        }
	    }]);

	    return GraphState;
	}((0, _immutable.Record)(defaultGraphState));

	exports.default = GraphState;

/***/ },
/* 3 */
/***/ function(module, exports) {

	/*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
	// css base code, injected by the css-loader
	module.exports = function() {
		var list = [];

		// return the list of modules as css string
		list.toString = function toString() {
			var result = [];
			for(var i = 0; i < this.length; i++) {
				var item = this[i];
				if(item[2]) {
					result.push("@media " + item[2] + "{" + item[1] + "}");
				} else {
					result.push(item[1]);
				}
			}
			return result.join("");
		};

		// import a list of modules into the list
		list.i = function(modules, mediaQuery) {
			if(typeof modules === "string")
				modules = [[null, modules, ""]];
			var alreadyImportedModules = {};
			for(var i = 0; i < this.length; i++) {
				var id = this[i][0];
				if(typeof id === "number")
					alreadyImportedModules[id] = true;
			}
			for(i = 0; i < modules.length; i++) {
				var item = modules[i];
				// skip already imported module
				// this implementation is not 100% perfect for weird media query combinations
				//  when a module is imported multiple times with different media queries.
				//  I hope this will never occur (Hey this way we have smaller bundles)
				if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
					if(mediaQuery && !item[2]) {
						item[2] = mediaQuery;
					} else if(mediaQuery) {
						item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
					}
					list.push(item);
				}
			}
		};
		return list;
	};


/***/ },
/* 4 */
/***/ function(module, exports) {

	"use strict";

	var detector = module.exports = {};

	detector.isIE = function(version) {
	    function isAnyIeVersion() {
	        var agent = navigator.userAgent.toLowerCase();
	        return agent.indexOf("msie") !== -1 || agent.indexOf("trident") !== -1 || agent.indexOf(" edge/") !== -1;
	    }

	    if(!isAnyIeVersion()) {
	        return false;
	    }

	    if(!version) {
	        return true;
	    }

	    //Shamelessly stolen from https://gist.github.com/padolsey/527683
	    var ieVersion = (function(){
	        var undef,
	            v = 3,
	            div = document.createElement("div"),
	            all = div.getElementsByTagName("i");

	        do {
	            div.innerHTML = "<!--[if gt IE " + (++v) + "]><i></i><![endif]-->";
	        }
	        while (all[0]);

	        return v > 4 ? v : undef;
	    }());

	    return version === ieVersion;
	};

	detector.isLegacyOpera = function() {
	    return !!window.opera;
	};


/***/ },
/* 5 */
/***/ function(module, exports) {

	"use strict";

	var utils = module.exports = {};

	/**
	 * Loops through the collection and calls the callback for each element. if the callback returns truthy, the loop is broken and returns the same value.
	 * @public
	 * @param {*} collection The collection to loop through. Needs to have a length property set and have indices set from 0 to length - 1.
	 * @param {function} callback The callback to be called for each element. The element will be given as a parameter to the callback. If this callback returns truthy, the loop is broken and the same value is returned.
	 * @returns {*} The value that a callback has returned (if truthy). Otherwise nothing.
	 */
	utils.forEach = function(collection, callback) {
	    for(var i = 0; i < collection.length; i++) {
	        var result = callback(collection[i]);
	        if(result) {
	            return result;
	        }
	    }
	};


/***/ },
/* 6 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports["default"] = getMargin;
	var toNumber = function toNumber(n) {
	  return parseInt(n) || 0;
	};

	function getMargin(style) {
	  return {
	    top: toNumber(style.marginTop),
	    right: toNumber(style.marginRight),
	    bottom: toNumber(style.marginBottom),
	    left: toNumber(style.marginLeft)
	  };
	}

	module.exports = exports["default"];

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = undefined;

	var _Measure = __webpack_require__(29);

	var _Measure2 = _interopRequireDefault(_Measure);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.default = _Measure2.default;
	module.exports = exports['default'];

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	/*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
	var stylesInDom = {},
		memoize = function(fn) {
			var memo;
			return function () {
				if (typeof memo === "undefined") memo = fn.apply(this, arguments);
				return memo;
			};
		},
		isOldIE = memoize(function() {
			return /msie [6-9]\b/.test(window.navigator.userAgent.toLowerCase());
		}),
		getHeadElement = memoize(function () {
			return document.head || document.getElementsByTagName("head")[0];
		}),
		singletonElement = null,
		singletonCounter = 0,
		styleElementsInsertedAtTop = [];

	module.exports = function(list, options) {
		if(true) {
			if(typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
		}

		options = options || {};
		// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
		// tags it will allow on a page
		if (typeof options.singleton === "undefined") options.singleton = isOldIE();

		// By default, add <style> tags to the bottom of <head>.
		if (typeof options.insertAt === "undefined") options.insertAt = "bottom";

		var styles = listToStyles(list);
		addStylesToDom(styles, options);

		return function update(newList) {
			var mayRemove = [];
			for(var i = 0; i < styles.length; i++) {
				var item = styles[i];
				var domStyle = stylesInDom[item.id];
				domStyle.refs--;
				mayRemove.push(domStyle);
			}
			if(newList) {
				var newStyles = listToStyles(newList);
				addStylesToDom(newStyles, options);
			}
			for(var i = 0; i < mayRemove.length; i++) {
				var domStyle = mayRemove[i];
				if(domStyle.refs === 0) {
					for(var j = 0; j < domStyle.parts.length; j++)
						domStyle.parts[j]();
					delete stylesInDom[domStyle.id];
				}
			}
		};
	}

	function addStylesToDom(styles, options) {
		for(var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];
			if(domStyle) {
				domStyle.refs++;
				for(var j = 0; j < domStyle.parts.length; j++) {
					domStyle.parts[j](item.parts[j]);
				}
				for(; j < item.parts.length; j++) {
					domStyle.parts.push(addStyle(item.parts[j], options));
				}
			} else {
				var parts = [];
				for(var j = 0; j < item.parts.length; j++) {
					parts.push(addStyle(item.parts[j], options));
				}
				stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
			}
		}
	}

	function listToStyles(list) {
		var styles = [];
		var newStyles = {};
		for(var i = 0; i < list.length; i++) {
			var item = list[i];
			var id = item[0];
			var css = item[1];
			var media = item[2];
			var sourceMap = item[3];
			var part = {css: css, media: media, sourceMap: sourceMap};
			if(!newStyles[id])
				styles.push(newStyles[id] = {id: id, parts: [part]});
			else
				newStyles[id].parts.push(part);
		}
		return styles;
	}

	function insertStyleElement(options, styleElement) {
		var head = getHeadElement();
		var lastStyleElementInsertedAtTop = styleElementsInsertedAtTop[styleElementsInsertedAtTop.length - 1];
		if (options.insertAt === "top") {
			if(!lastStyleElementInsertedAtTop) {
				head.insertBefore(styleElement, head.firstChild);
			} else if(lastStyleElementInsertedAtTop.nextSibling) {
				head.insertBefore(styleElement, lastStyleElementInsertedAtTop.nextSibling);
			} else {
				head.appendChild(styleElement);
			}
			styleElementsInsertedAtTop.push(styleElement);
		} else if (options.insertAt === "bottom") {
			head.appendChild(styleElement);
		} else {
			throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");
		}
	}

	function removeStyleElement(styleElement) {
		styleElement.parentNode.removeChild(styleElement);
		var idx = styleElementsInsertedAtTop.indexOf(styleElement);
		if(idx >= 0) {
			styleElementsInsertedAtTop.splice(idx, 1);
		}
	}

	function createStyleElement(options) {
		var styleElement = document.createElement("style");
		styleElement.type = "text/css";
		insertStyleElement(options, styleElement);
		return styleElement;
	}

	function createLinkElement(options) {
		var linkElement = document.createElement("link");
		linkElement.rel = "stylesheet";
		insertStyleElement(options, linkElement);
		return linkElement;
	}

	function addStyle(obj, options) {
		var styleElement, update, remove;

		if (options.singleton) {
			var styleIndex = singletonCounter++;
			styleElement = singletonElement || (singletonElement = createStyleElement(options));
			update = applyToSingletonTag.bind(null, styleElement, styleIndex, false);
			remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true);
		} else if(obj.sourceMap &&
			typeof URL === "function" &&
			typeof URL.createObjectURL === "function" &&
			typeof URL.revokeObjectURL === "function" &&
			typeof Blob === "function" &&
			typeof btoa === "function") {
			styleElement = createLinkElement(options);
			update = updateLink.bind(null, styleElement);
			remove = function() {
				removeStyleElement(styleElement);
				if(styleElement.href)
					URL.revokeObjectURL(styleElement.href);
			};
		} else {
			styleElement = createStyleElement(options);
			update = applyToTag.bind(null, styleElement);
			remove = function() {
				removeStyleElement(styleElement);
			};
		}

		update(obj);

		return function updateStyle(newObj) {
			if(newObj) {
				if(newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap)
					return;
				update(obj = newObj);
			} else {
				remove();
			}
		};
	}

	var replaceText = (function () {
		var textStore = [];

		return function (index, replacement) {
			textStore[index] = replacement;
			return textStore.filter(Boolean).join('\n');
		};
	})();

	function applyToSingletonTag(styleElement, index, remove, obj) {
		var css = remove ? "" : obj.css;

		if (styleElement.styleSheet) {
			styleElement.styleSheet.cssText = replaceText(index, css);
		} else {
			var cssNode = document.createTextNode(css);
			var childNodes = styleElement.childNodes;
			if (childNodes[index]) styleElement.removeChild(childNodes[index]);
			if (childNodes.length) {
				styleElement.insertBefore(cssNode, childNodes[index]);
			} else {
				styleElement.appendChild(cssNode);
			}
		}
	}

	function applyToTag(styleElement, obj) {
		var css = obj.css;
		var media = obj.media;

		if(media) {
			styleElement.setAttribute("media", media)
		}

		if(styleElement.styleSheet) {
			styleElement.styleSheet.cssText = css;
		} else {
			while(styleElement.firstChild) {
				styleElement.removeChild(styleElement.firstChild);
			}
			styleElement.appendChild(document.createTextNode(css));
		}
	}

	function updateLink(linkElement, obj) {
		var css = obj.css;
		var sourceMap = obj.sourceMap;

		if(sourceMap) {
			// http://stackoverflow.com/a/26603875
			css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
		}

		var blob = new Blob([css], { type: "text/css" });

		var oldSrc = linkElement.href;

		linkElement.href = URL.createObjectURL(blob);

		if(oldSrc)
			URL.revokeObjectURL(oldSrc);
	}


/***/ },
/* 9 */
/***/ function(module, exports) {

	module.exports = Immutable;

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Edge = function (_Component) {
	    _inherits(Edge, _Component);

	    function Edge() {
	        _classCallCheck(this, Edge);

	        return _possibleConstructorReturn(this, (Edge.__proto__ || Object.getPrototypeOf(Edge)).apply(this, arguments));
	    }

	    _createClass(Edge, [{
	        key: 'shouldComponentUpdate',
	        value: function shouldComponentUpdate(nextProps) {
	            return this.props.edge !== nextProps.edge || this.props.origin !== nextProps.origin || this.props.dest !== nextProps.dest;
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var _props$edge = this.props.edge,
	                output = _props$edge.output,
	                input = _props$edge.input,
	                color = _props$edge.color;

	            var from = this.props.origin;
	            var to = this.props.dest;

	            var start = {
	                x: from.x + from.width,
	                y: from.y + from.minPin + (output + 0.5) * from.pinHeight
	            };
	            var end = {
	                x: to.x,
	                y: to.y + to.minPin + (input + 0.5) * to.pinHeight
	            };
	            var delta = {
	                x: end.x - start.x,
	                y: end.y - start.y
	            };

	            var goingForward = delta.x >= 0.0;
	            var tension = {
	                x: Math.min(Math.abs(delta.x), goingForward ? 1000 : 200),
	                y: Math.min(Math.abs(delta.y), goingForward ? 1000 : 200)
	            };

	            var tangent = goingForward ? {
	                x: (tension.x + tension.y) * 0.5,
	                y: 0
	            } : {
	                x: tension.x * 1.5 + tension.y * 0.75,
	                y: 0
	            };

	            return _react2.default.createElement('path', {
	                fill: 'none',
	                stroke: color,
	                d: '\n                    M' + start.x + ' ' + start.y + '\n                    C' + (start.x + tangent.x) + ' ' + (start.y + tangent.y) + ',\n                     ' + (end.x - tangent.x) + ' ' + (end.y - tangent.y) + ',\n                     ' + end.x + ' ' + end.y + '\n                 ' });
	        }
	    }]);

	    return Edge;
	}(_react.Component);

	exports.default = Edge;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _immutable = __webpack_require__(9);

	var _node = __webpack_require__(12);

	var _node2 = _interopRequireDefault(_node);

	var _edge = __webpack_require__(10);

	var _edge2 = _interopRequireDefault(_edge);

	var _state = __webpack_require__(2);

	var _graph = __webpack_require__(31);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	// eslint-disable-next-line no-duplicate-imports


	function NOOP() {}

	var raf = (window ? window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.msRequestAnimationFrame : null) || function (cb) {
	    return setTimeout(cb, 16);
	};

	var Graph = function (_Component) {
	    _inherits(Graph, _Component);

	    function Graph(props) {
	        _classCallCheck(this, Graph);

	        var _this = _possibleConstructorReturn(this, (Graph.__proto__ || Object.getPrototypeOf(Graph)).call(this, props));

	        _this.__actionQueue = new _immutable.List();

	        _this.mouseDown = function (evt) {
	            evt.preventDefault();

	            if (_this.__graph) {
	                var _nextState = _this.props.value;
	                if (evt.target === _this.__graph) {
	                    _nextState = _nextState.closeMenu();
	                }

	                var _this$getGraphCoords = _this.getGraphCoords(evt),
	                    _x = _this$getGraphCoords.x,
	                    _y = _this$getGraphCoords.y;

	                _this.props.onChange(_nextState._startMouse(_x, _y));
	            }
	        };

	        _this.mouseMove = function (evt) {
	            if (_this.__graph && _this.props.value.mouseState.down) {
	                evt.preventDefault();
	                evt.stopPropagation();

	                var _this$getGraphCoords2 = _this.getGraphCoords(evt),
	                    _x2 = _this$getGraphCoords2.x,
	                    _y2 = _this$getGraphCoords2.y;

	                _this.props.onChange(_this.props.value._updateMouse(_x2, _y2));
	            }
	        };

	        _this.mouseUp = function (evt) {
	            if (_this.props.value.mouseState.down) {
	                evt.preventDefault();
	                evt.stopPropagation();

	                var _nextState2 = _this.props.value._endMouse();
	                if (_this.props.value.mouseState.draggingEdge) {
	                    var _this$getGraphCoords3 = _this.getGraphCoords(evt),
	                        _x3 = _this$getGraphCoords3.x,
	                        _y3 = _this$getGraphCoords3.y;

	                    _nextState2 = _nextState2.openMenu(_x3, _y3);
	                }

	                _this.props.onChange(_nextState2);
	            }
	        };

	        _this.contextMenu = function (evt) {
	            evt.preventDefault();

	            var _this$getGraphCoords4 = _this.getGraphCoords(evt),
	                x = _this$getGraphCoords4.x,
	                y = _this$getGraphCoords4.y;

	            _this.props.onChange(_this.props.value.openMenu(x, y));
	        };

	        _this.updateSVG = function (svg) {
	            if (svg) {
	                var bbox = svg.getBBox();
	                svg.setAttribute('width', bbox.x + bbox.width + 'px');
	                svg.setAttribute('height', bbox.y + bbox.height + 'px');

	                _this.__svg = svg;
	            }
	        };

	        _this.measureNode = function (id, width, height) {
	            _this.batchAction({
	                method: '_measureNode',
	                args: [id, width, height]
	            });
	        };

	        _this.measurePin = function (id, y, height) {
	            _this.batchAction({
	                method: '_measurePin',
	                args: [id, y, height]
	            });
	        };

	        _this.clickNode = function (id, evt) {
	            if (!_this.isSelected(id)) {
	                _this.props.onChange(_this.props.value.selectNode(id, evt.ctrlKey));
	            }
	        };

	        _this.moveNode = function (id, x, y) {
	            var final = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

	            _this.props.onChange(_this.props.value.moveNode(id, x, y, final));
	        };

	        _this.dragPin = function (node, pin, evt) {
	            if (_this.__graph) {
	                evt.preventDefault();
	                evt.stopPropagation();

	                var _this$getGraphCoords5 = _this.getGraphCoords(evt),
	                    _x5 = _this$getGraphCoords5.x,
	                    _y4 = _this$getGraphCoords5.y;

	                _this.props.onChange(_this.props.value._startMouse(_x5, _y4)._startConnection(node, pin));
	            }
	        };

	        _this.dropPin = function (node, pin, evt) {
	            evt.preventDefault();
	            evt.stopPropagation();

	            _this.props.onChange(_this.props.value._endConnection(node, pin));
	        };
	        return _this;
	    }

	    _createClass(Graph, [{
	        key: 'componentDidUpdate',
	        value: function componentDidUpdate() {
	            this.updateSVG(this.__svg);
	        }
	    }, {
	        key: 'getGraphCoords',
	        value: function getGraphCoords(evt) {
	            return {
	                x: evt.clientX + this.__graph.scrollLeft,
	                y: evt.clientY + this.__graph.scrollTop
	            };
	        }
	    }, {
	        key: 'isSelected',
	        value: function isSelected(node) {
	            return this.props.value.isSelected(node);
	        }
	    }, {
	        key: 'batchAction',
	        value: function batchAction(action) {
	            var _this2 = this;

	            if (this.__actionQueue.isEmpty()) {
	                raf(function () {
	                    var currentQueue = _this2.__actionQueue;
	                    _this2.__actionQueue = _this2.__actionQueue.clear();

	                    _this2.props.onChange(currentQueue.reduce(function (state, item) {
	                        return state[item.method].apply(state, _toConsumableArray(item.args));
	                    }, _this2.props.value));
	                });
	            }

	            this.__actionQueue = this.__actionQueue.push(action);
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var _this3 = this;

	            var _props = this.props,
	                nodeClass = _props.nodeClass,
	                pinClass = _props.pinClass,
	                MenuClass = _props.menuClass,
	                className = _props.className;
	            var _props$value = this.props.value,
	                editorState = _props$value.editorState,
	                mouseState = _props$value.mouseState,
	                menuState = _props$value.menuState;
	            var nodes = editorState.nodes,
	                edges = editorState.edges;


	            var dragLine = function dragLine() {
	                if (!mouseState.down) {
	                    return null;
	                }

	                if (mouseState.draggingEdge) {
	                    return _react2.default.createElement(_edge2.default, { origin: nodes.get(mouseState.node), dest: new _state.Node({
	                            x: mouseState.x,
	                            y: mouseState.y,
	                            minPin: 0
	                        }), edge: {
	                            output: mouseState.pin,
	                            input: 0,
	                            color: '#fff'
	                        } });
	                }

	                var _mouseState$rect = mouseState.rect,
	                    minX = _mouseState$rect.minX,
	                    minY = _mouseState$rect.minY,
	                    maxX = _mouseState$rect.maxX,
	                    maxY = _mouseState$rect.maxY;


	                return _react2.default.createElement('rect', {
	                    x: minX, y: minY,
	                    width: maxX - minX,
	                    height: maxY - minY });
	            };

	            return _react2.default.createElement(
	                'div',
	                {
	                    className: _graph.graph + ' ' + className,
	                    onMouseDown: this.mouseDown,
	                    onMouseMove: this.mouseMove,
	                    onMouseUp: this.mouseUp,
	                    onContextMenu: this.contextMenu,
	                    ref: function ref(elem) {
	                        _this3.__graph = elem;
	                    } },
	                _react2.default.createElement(
	                    'svg',
	                    { ref: this.updateSVG },
	                    edges.map(function (edge) {
	                        var from = nodes.get(edge.from);
	                        var to = nodes.get(edge.to);

	                        return from && to && _react2.default.createElement(_edge2.default, {
	                            key: from.id + ':' + edge.output + '-' + to.id + ':' + edge.input,
	                            origin: from, dest: to,
	                            edge: edge });
	                    }),
	                    dragLine
	                ),
	                nodes.map(function (node) {
	                    return _react2.default.createElement(_node2.default, { key: node.id, node: node,
	                        nodeClass: nodeClass,
	                        pinClass: pinClass,
	                        measureNode: _this3.measureNode,
	                        measurePin: _this3.measurePin,
	                        moveNode: _this3.moveNode,
	                        mouseDown: _this3.clickNode,
	                        dragPin: mouseState.draggingEdge ? NOOP : _this3.dragPin,
	                        dropPin: mouseState.draggingEdge ? _this3.dropPin : NOOP,
	                        selected: _this3.isSelected(node.id) });
	                }).toArray(),
	                MenuClass && menuState.open && _react2.default.createElement(MenuClass, { menu: menuState })
	            );
	        }
	    }]);

	    return Graph;
	}(_react.Component);

	exports.default = Graph;

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _reactMeasure = __webpack_require__(7);

	var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

	var _pin = __webpack_require__(13);

	var _pin2 = _interopRequireDefault(_pin);

	var _node = __webpack_require__(32);

	var _node2 = _interopRequireDefault(_node);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	function NOOP() {}

	var Node = function (_Component) {
	    _inherits(Node, _Component);

	    function Node(props) {
	        _classCallCheck(this, Node);

	        var _this = _possibleConstructorReturn(this, (Node.__proto__ || Object.getPrototypeOf(Node)).call(this, props));

	        _this.mouseDown = function (evt) {
	            evt.preventDefault();
	            evt.stopPropagation();

	            _this.__nodeStartX = _this.props.node.x;
	            _this.__nodeStartY = _this.props.node.y;
	            _this.__mouseStartX = evt.clientX;
	            _this.__mouseStartY = evt.clientY;

	            window.addEventListener('mousemove', _this.mouseMove);
	            window.addEventListener('mouseup', _this.mouseUp);

	            _this.props.mouseDown(_this.props.node.id, evt);
	        };

	        _this.mouseMove = function (evt) {
	            evt.preventDefault();

	            _this.props.moveNode(_this.props.node.id, _this.__nodeStartX + (evt.clientX - _this.__mouseStartX), _this.__nodeStartY + (evt.clientY - _this.__mouseStartY));
	        };

	        _this.mouseUp = function (evt) {
	            evt.preventDefault();

	            _this.props.moveNode(_this.props.node.id, _this.__nodeStartX + (evt.clientX - _this.__mouseStartX), _this.__nodeStartY + (evt.clientY - _this.__mouseStartY), true);

	            window.removeEventListener('mousemove', _this.mouseMove);
	            window.removeEventListener('mouseup', _this.mouseUp);
	        };

	        _this.measureNode = function (rect) {
	            _this.props.measureNode(_this.props.node.id, rect.width, rect.height);
	        };

	        _this.measurePin = function (y, height) {
	            _this.props.measurePin(_this.props.node.id, y, height);
	        };

	        _this.dragPin = function (pin, evt) {
	            _this.props.dragPin(_this.props.node, pin, evt);
	        };

	        _this.dropPin = function (pin, evt) {
	            _this.props.dropPin(_this.props.node, pin, evt);
	        };
	        return _this;
	    }

	    _createClass(Node, [{
	        key: 'shouldComponentUpdate',
	        value: function shouldComponentUpdate(nextProps) {
	            return this.props.node !== nextProps.node || this.props.dropPin !== nextProps.dropPin || this.props.selected !== nextProps.selected;
	        }
	    }, {
	        key: 'componentWillUnmount',
	        value: function componentWillUnmount() {
	            window.removeEventListener('mousemove', this.mouseMove);
	            window.removeEventListener('mouseup', this.mouseUp);
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var _this2 = this;

	            var NodeClass = this.props.nodeClass;

	            return _react2.default.createElement(
	                _reactMeasure2.default,
	                { whiteList: ['width', 'height'], onMeasure: this.measureNode },
	                _react2.default.createElement(
	                    'div',
	                    { className: _node2.default.node, onMouseDown: this.mouseDown, style: {
	                            transform: 'translate(' + this.props.node.x + 'px, ' + this.props.node.y + 'px)'
	                        } },
	                    _react2.default.createElement(NodeClass, {
	                        node: this.props.node,
	                        selected: this.props.selected,
	                        inputs: this.props.node.inputs.map(function (pin) {
	                            return _react2.default.createElement(_pin2.default, { key: pin.name, pin: pin,
	                                pinClass: _this2.props.pinClass,
	                                onDrag: NOOP, onDrop: _this2.dropPin,
	                                shouldMeasure: _this2.props.node.height > 0,
	                                onMeasure: _this2.measurePin });
	                        }),
	                        outputs: this.props.node.outputs.map(function (pin) {
	                            return _react2.default.createElement(_pin2.default, { key: pin.name, pin: pin,
	                                pinClass: _this2.props.pinClass,
	                                onDrop: NOOP, onDrag: _this2.dragPin,
	                                shouldMeasure: _this2.props.node.height > 0,
	                                onMeasure: _this2.measurePin });
	                        }) })
	                )
	            );
	        }
	    }]);

	    return Node;
	}(_react.Component);

	exports.default = Node;

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _reactMeasure = __webpack_require__(7);

	var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Pin = function (_Component) {
	    _inherits(Pin, _Component);

	    function Pin(props) {
	        _classCallCheck(this, Pin);

	        var _this = _possibleConstructorReturn(this, (Pin.__proto__ || Object.getPrototypeOf(Pin)).call(this, props));

	        _this.onMouseDown = function (evt) {
	            _this.props.onDrag(_this.props.pin, evt);
	        };

	        _this.onMouseUp = function (evt) {
	            _this.props.onDrop(_this.props.pin, evt);
	        };

	        _this.measure = function (rect) {
	            _this.props.onMeasure(rect.top, rect.height);
	        };
	        return _this;
	    }

	    _createClass(Pin, [{
	        key: 'shouldComponentUpdate',
	        value: function shouldComponentUpdate(nextProps) {
	            return this.props.pin !== nextProps.pin || this.props.shouldMeasure !== nextProps.shouldMeasure || this.props.onDrop !== nextProps.onDrop;
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var PinClass = this.props.pinClass;

	            return _react2.default.createElement(
	                _reactMeasure2.default,
	                { whiteList: ['top', 'height'], shouldMeasure: this.props.shouldMeasure, onMeasure: this.measure },
	                _react2.default.createElement(
	                    'div',
	                    { style: {
	                            display: 'inline-block'
	                        }, onMouseDown: this.onMouseDown, onMouseUp: this.onMouseUp },
	                    _react2.default.createElement(PinClass, { pin: this.props.pin })
	                )
	            );
	        }
	    }]);

	    return Pin;
	}(_react.Component);

	exports.default = Pin;

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	var utils = __webpack_require__(15);

	module.exports = function batchProcessorMaker(options) {
	    options             = options || {};
	    var reporter        = options.reporter;
	    var asyncProcess    = utils.getOption(options, "async", true);
	    var autoProcess     = utils.getOption(options, "auto", true);

	    if(autoProcess && !asyncProcess) {
	        reporter && reporter.warn("Invalid options combination. auto=true and async=false is invalid. Setting async=true.");
	        asyncProcess = true;
	    }

	    var batch = Batch();
	    var asyncFrameHandler;
	    var isProcessing = false;

	    function addFunction(level, fn) {
	        if(!isProcessing && autoProcess && asyncProcess && batch.size() === 0) {
	            // Since this is async, it is guaranteed to be executed after that the fn is added to the batch.
	            // This needs to be done before, since we're checking the size of the batch to be 0.
	            processBatchAsync();
	        }

	        batch.add(level, fn);
	    }

	    function processBatch() {
	        // Save the current batch, and create a new batch so that incoming functions are not added into the currently processing batch.
	        // Continue processing until the top-level batch is empty (functions may be added to the new batch while processing, and so on).
	        isProcessing = true;
	        while (batch.size()) {
	            var processingBatch = batch;
	            batch = Batch();
	            processingBatch.process();
	        }
	        isProcessing = false;
	    }

	    function forceProcessBatch(localAsyncProcess) {
	        if (isProcessing) {
	            return;
	        }

	        if(localAsyncProcess === undefined) {
	            localAsyncProcess = asyncProcess;
	        }

	        if(asyncFrameHandler) {
	            cancelFrame(asyncFrameHandler);
	            asyncFrameHandler = null;
	        }

	        if(localAsyncProcess) {
	            processBatchAsync();
	        } else {
	            processBatch();
	        }
	    }

	    function processBatchAsync() {
	        asyncFrameHandler = requestFrame(processBatch);
	    }

	    function clearBatch() {
	        batch           = {};
	        batchSize       = 0;
	        topLevel        = 0;
	        bottomLevel     = 0;
	    }

	    function cancelFrame(listener) {
	        // var cancel = window.cancelAnimationFrame || window.mozCancelAnimationFrame || window.webkitCancelAnimationFrame || window.clearTimeout;
	        var cancel = clearTimeout;
	        return cancel(listener);
	    }

	    function requestFrame(callback) {
	        // var raf = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || function(fn) { return window.setTimeout(fn, 20); };
	        var raf = function(fn) { return setTimeout(fn, 0); };
	        return raf(callback);
	    }

	    return {
	        add: addFunction,
	        force: forceProcessBatch
	    };
	};

	function Batch() {
	    var batch       = {};
	    var size        = 0;
	    var topLevel    = 0;
	    var bottomLevel = 0;

	    function add(level, fn) {
	        if(!fn) {
	            fn = level;
	            level = 0;
	        }

	        if(level > topLevel) {
	            topLevel = level;
	        } else if(level < bottomLevel) {
	            bottomLevel = level;
	        }

	        if(!batch[level]) {
	            batch[level] = [];
	        }

	        batch[level].push(fn);
	        size++;
	    }

	    function process() {
	        for(var level = bottomLevel; level <= topLevel; level++) {
	            var fns = batch[level];

	            for(var i = 0; i < fns.length; i++) {
	                var fn = fns[i];
	                fn();
	            }
	        }
	    }

	    function getSize() {
	        return size;
	    }

	    return {
	        add: add,
	        process: process,
	        size: getSize
	    };
	}


/***/ },
/* 15 */
/***/ function(module, exports) {

	"use strict";

	var utils = module.exports = {};

	utils.getOption = getOption;

	function getOption(options, name, defaultValue) {
	    var value = options[name];

	    if((value === undefined || value === null) && defaultValue !== undefined) {
	        return defaultValue;
	    }

	    return value;
	}


/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	exports = module.exports = __webpack_require__(3)();
	// imports


	// module
	exports.push([module.id, ".__react-graph-editor__graph__graph__1A2yG{position:relative}.__react-graph-editor__graph__graph__1A2yG>*{position:absolute;z-index:2}.__react-graph-editor__graph__graph__1A2yG>svg{z-index:1;top:0;left:0}.__react-graph-editor__graph__graph__1A2yG>svg>rect{stroke:orange;fill:rgba(255,165,0,.2)}", ""]);

	// exports
	exports.locals = {
		"graph": "__react-graph-editor__graph__graph__1A2yG"
	};

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	exports = module.exports = __webpack_require__(3)();
	// imports


	// module
	exports.push([module.id, ".__react-graph-editor__node__node__TEe8W{display:flex;flex-direction:column}", ""]);

	// exports
	exports.locals = {
		"node": "__react-graph-editor__node__node__TEe8W"
	};

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Resize detection strategy that injects objects to elements in order to detect resize events.
	 * Heavily inspired by: http://www.backalleycoder.com/2013/03/18/cross-browser-event-based-element-resize-detection/
	 */

	"use strict";

	var browserDetector = __webpack_require__(4);

	module.exports = function(options) {
	    options             = options || {};
	    var reporter        = options.reporter;
	    var batchProcessor  = options.batchProcessor;
	    var getState        = options.stateHandler.getState;

	    if(!reporter) {
	        throw new Error("Missing required dependency: reporter.");
	    }

	    /**
	     * Adds a resize event listener to the element.
	     * @public
	     * @param {element} element The element that should have the listener added.
	     * @param {function} listener The listener callback to be called for each resize event of the element. The element will be given as a parameter to the listener callback.
	     */
	    function addListener(element, listener) {
	        if(!getObject(element)) {
	            throw new Error("Element is not detectable by this strategy.");
	        }

	        function listenerProxy() {
	            listener(element);
	        }

	        if(browserDetector.isIE(8)) {
	            //IE 8 does not support object, but supports the resize event directly on elements.
	            getState(element).object = {
	                proxy: listenerProxy
	            };
	            element.attachEvent("onresize", listenerProxy);
	        } else {
	            var object = getObject(element);
	            object.contentDocument.defaultView.addEventListener("resize", listenerProxy);
	        }
	    }

	    /**
	     * Makes an element detectable and ready to be listened for resize events. Will call the callback when the element is ready to be listened for resize changes.
	     * @private
	     * @param {object} options Optional options object.
	     * @param {element} element The element to make detectable
	     * @param {function} callback The callback to be called when the element is ready to be listened for resize changes. Will be called with the element as first parameter.
	     */
	    function makeDetectable(options, element, callback) {
	        if (!callback) {
	            callback = element;
	            element = options;
	            options = null;
	        }

	        options = options || {};
	        var debug = options.debug;

	        function injectObject(element, callback) {
	            var OBJECT_STYLE = "display: block; position: absolute; top: 0; left: 0; width: 100%; height: 100%; border: none; padding: 0; margin: 0; opacity: 0; z-index: -1000; pointer-events: none;";

	            //The target element needs to be positioned (everything except static) so the absolute positioned object will be positioned relative to the target element.

	            // Position altering may be performed directly or on object load, depending on if style resolution is possible directly or not.
	            var positionCheckPerformed = false;

	            // The element may not yet be attached to the DOM, and therefore the style object may be empty in some browsers.
	            // Since the style object is a reference, it will be updated as soon as the element is attached to the DOM.
	            var style = window.getComputedStyle(element);
	            var width = element.offsetWidth;
	            var height = element.offsetHeight;

	            getState(element).startSize = {
	                width: width,
	                height: height
	            };

	            function mutateDom() {
	                function alterPositionStyles() {
	                    if(style.position === "static") {
	                        element.style.position = "relative";

	                        var removeRelativeStyles = function(reporter, element, style, property) {
	                            function getNumericalValue(value) {
	                                return value.replace(/[^-\d\.]/g, "");
	                            }

	                            var value = style[property];

	                            if(value !== "auto" && getNumericalValue(value) !== "0") {
	                                reporter.warn("An element that is positioned static has style." + property + "=" + value + " which is ignored due to the static positioning. The element will need to be positioned relative, so the style." + property + " will be set to 0. Element: ", element);
	                                element.style[property] = 0;
	                            }
	                        };

	                        //Check so that there are no accidental styles that will make the element styled differently now that is is relative.
	                        //If there are any, set them to 0 (this should be okay with the user since the style properties did nothing before [since the element was positioned static] anyway).
	                        removeRelativeStyles(reporter, element, style, "top");
	                        removeRelativeStyles(reporter, element, style, "right");
	                        removeRelativeStyles(reporter, element, style, "bottom");
	                        removeRelativeStyles(reporter, element, style, "left");
	                    }
	                }

	                function onObjectLoad() {
	                    // The object has been loaded, which means that the element now is guaranteed to be attached to the DOM.
	                    if (!positionCheckPerformed) {
	                        alterPositionStyles();
	                    }

	                    /*jshint validthis: true */

	                    function getDocument(element, callback) {
	                        //Opera 12 seem to call the object.onload before the actual document has been created.
	                        //So if it is not present, poll it with an timeout until it is present.
	                        //TODO: Could maybe be handled better with object.onreadystatechange or similar.
	                        if(!element.contentDocument) {
	                            setTimeout(function checkForObjectDocument() {
	                                getDocument(element, callback);
	                            }, 100);

	                            return;
	                        }

	                        callback(element.contentDocument);
	                    }

	                    //Mutating the object element here seems to fire another load event.
	                    //Mutating the inner document of the object element is fine though.
	                    var objectElement = this;

	                    //Create the style element to be added to the object.
	                    getDocument(objectElement, function onObjectDocumentReady(objectDocument) {
	                        //Notify that the element is ready to be listened to.
	                        callback(element);
	                    });
	                }

	                // The element may be detached from the DOM, and some browsers does not support style resolving of detached elements.
	                // The alterPositionStyles needs to be delayed until we know the element has been attached to the DOM (which we are sure of when the onObjectLoad has been fired), if style resolution is not possible.
	                if (style.position !== "") {
	                    alterPositionStyles(style);
	                    positionCheckPerformed = true;
	                }

	                //Add an object element as a child to the target element that will be listened to for resize events.
	                var object = document.createElement("object");
	                object.style.cssText = OBJECT_STYLE;
	                object.type = "text/html";
	                object.onload = onObjectLoad;

	                //Safari: This must occur before adding the object to the DOM.
	                //IE: Does not like that this happens before, even if it is also added after.
	                if(!browserDetector.isIE()) {
	                    object.data = "about:blank";
	                }

	                element.appendChild(object);
	                getState(element).object = object;

	                //IE: This must occur after adding the object to the DOM.
	                if(browserDetector.isIE()) {
	                    object.data = "about:blank";
	                }
	            }

	            if(batchProcessor) {
	                batchProcessor.add(mutateDom);
	            } else {
	                mutateDom();
	            }
	        }

	        if(browserDetector.isIE(8)) {
	            //IE 8 does not support objects properly. Luckily they do support the resize event.
	            //So do not inject the object and notify that the element is already ready to be listened to.
	            //The event handler for the resize event is attached in the utils.addListener instead.
	            callback(element);
	        } else {
	            injectObject(element, callback);
	        }
	    }

	    /**
	     * Returns the child object of the target element.
	     * @private
	     * @param {element} element The target element.
	     * @returns The object element of the target.
	     */
	    function getObject(element) {
	        return getState(element).object;
	    }

	    function uninstall(element) {
	        if(browserDetector.isIE(8)) {
	            element.detachEvent("onresize", getState(element).object.proxy);
	        } else {
	            element.removeChild(getObject(element));
	        }
	        delete getState(element).object;
	    }

	    return {
	        makeDetectable: makeDetectable,
	        addListener: addListener,
	        uninstall: uninstall
	    };
	};


/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Resize detection strategy that injects divs to elements in order to detect resize events on scroll events.
	 * Heavily inspired by: https://github.com/marcj/css-element-queries/blob/master/src/ResizeSensor.js
	 */

	"use strict";

	var forEach = __webpack_require__(5).forEach;

	module.exports = function(options) {
	    options             = options || {};
	    var reporter        = options.reporter;
	    var batchProcessor  = options.batchProcessor;
	    var getState        = options.stateHandler.getState;
	    var hasState        = options.stateHandler.hasState;
	    var idHandler       = options.idHandler;

	    if (!batchProcessor) {
	        throw new Error("Missing required dependency: batchProcessor");
	    }

	    if (!reporter) {
	        throw new Error("Missing required dependency: reporter.");
	    }

	    //TODO: Could this perhaps be done at installation time?
	    var scrollbarSizes = getScrollbarSizes();

	    // Inject the scrollbar styling that prevents them from appearing sometimes in Chrome.
	    // The injected container needs to have a class, so that it may be styled with CSS (pseudo elements).
	    var styleId = "erd_scroll_detection_scrollbar_style";
	    var detectionContainerClass = "erd_scroll_detection_container";
	    injectScrollStyle(styleId, detectionContainerClass);

	    function getScrollbarSizes() {
	        var width = 500;
	        var height = 500;

	        var child = document.createElement("div");
	        child.style.cssText = "position: absolute; width: " + width*2 + "px; height: " + height*2 + "px; visibility: hidden; margin: 0; padding: 0;";

	        var container = document.createElement("div");
	        container.style.cssText = "position: absolute; width: " + width + "px; height: " + height + "px; overflow: scroll; visibility: none; top: " + -width*3 + "px; left: " + -height*3 + "px; visibility: hidden; margin: 0; padding: 0;";

	        container.appendChild(child);

	        document.body.insertBefore(container, document.body.firstChild);

	        var widthSize = width - container.clientWidth;
	        var heightSize = height - container.clientHeight;

	        document.body.removeChild(container);

	        return {
	            width: widthSize,
	            height: heightSize
	        };
	    }

	    function injectScrollStyle(styleId, containerClass) {
	        function injectStyle(style, method) {
	            method = method || function (element) {
	                document.head.appendChild(element);
	            };

	            var styleElement = document.createElement("style");
	            styleElement.innerHTML = style;
	            styleElement.id = styleId;
	            method(styleElement);
	            return styleElement;
	        }

	        if (!document.getElementById(styleId)) {
	            var containerAnimationClass = containerClass + "_animation";
	            var containerAnimationActiveClass = containerClass + "_animation_active";
	            var style = "/* Created by the element-resize-detector library. */\n";
	            style += "." + containerClass + " > div::-webkit-scrollbar { display: none; }\n\n";
	            style += "." + containerAnimationActiveClass + " { -webkit-animation-duration: 0.1s; animation-duration: 0.1s; -webkit-animation-name: " + containerAnimationClass + "; animation-name: " + containerAnimationClass + "; }\n";
	            style += "@-webkit-keyframes " + containerAnimationClass +  " { 0% { opacity: 1; } 50% { opacity: 0; } 100% { opacity: 1; } }\n";
	            style += "@keyframes " + containerAnimationClass +          " { 0% { opacity: 1; } 50% { opacity: 0; } 100% { opacity: 1; } }";
	            injectStyle(style);
	        }
	    }

	    function addAnimationClass(element) {
	        element.className += " " + detectionContainerClass + "_animation_active";
	    }

	    function addEvent(el, name, cb) {
	        if (el.addEventListener) {
	            el.addEventListener(name, cb);
	        } else if(el.attachEvent) {
	            el.attachEvent("on" + name, cb);
	        } else {
	            return reporter.error("[scroll] Don't know how to add event listeners.");
	        }
	    }

	    function removeEvent(el, name, cb) {
	        if (el.removeEventListener) {
	            el.removeEventListener(name, cb);
	        } else if(el.detachEvent) {
	            el.detachEvent("on" + name, cb);
	        } else {
	            return reporter.error("[scroll] Don't know how to remove event listeners.");
	        }
	    }

	    function getExpandElement(element) {
	        return getState(element).container.childNodes[0].childNodes[0].childNodes[0];
	    }

	    function getShrinkElement(element) {
	        return getState(element).container.childNodes[0].childNodes[0].childNodes[1];
	    }

	    /**
	     * Adds a resize event listener to the element.
	     * @public
	     * @param {element} element The element that should have the listener added.
	     * @param {function} listener The listener callback to be called for each resize event of the element. The element will be given as a parameter to the listener callback.
	     */
	    function addListener(element, listener) {
	        var listeners = getState(element).listeners;

	        if (!listeners.push) {
	            throw new Error("Cannot add listener to an element that is not detectable.");
	        }

	        getState(element).listeners.push(listener);
	    }

	    /**
	     * Makes an element detectable and ready to be listened for resize events. Will call the callback when the element is ready to be listened for resize changes.
	     * @private
	     * @param {object} options Optional options object.
	     * @param {element} element The element to make detectable
	     * @param {function} callback The callback to be called when the element is ready to be listened for resize changes. Will be called with the element as first parameter.
	     */
	    function makeDetectable(options, element, callback) {
	        if (!callback) {
	            callback = element;
	            element = options;
	            options = null;
	        }

	        options = options || {};

	        function debug() {
	            if (options.debug) {
	                var args = Array.prototype.slice.call(arguments);
	                args.unshift(idHandler.get(element), "Scroll: ");
	                if (reporter.log.apply) {
	                    reporter.log.apply(null, args);
	                } else {
	                    for (var i = 0; i < args.length; i++) {
	                        reporter.log(args[i]);
	                    }
	                }
	            }
	        }

	        function isDetached(element) {
	            function isInDocument(element) {
	                return element === element.ownerDocument.body || element.ownerDocument.body.contains(element);
	            }
	            return !isInDocument(element);
	        }

	        function isUnrendered(element) {
	            // Check the absolute positioned container since the top level container is display: inline.
	            var container = getState(element).container.childNodes[0];
	            return getComputedStyle(container).width.indexOf("px") === -1; //Can only compute pixel value when rendered.
	        }

	        function getStyle() {
	            // Some browsers only force layouts when actually reading the style properties of the style object, so make sure that they are all read here,
	            // so that the user of the function can be sure that it will perform the layout here, instead of later (important for batching).
	            var elementStyle            = getComputedStyle(element);
	            var style                   = {};
	            style.position              = elementStyle.position;
	            style.width                 = element.offsetWidth;
	            style.height                = element.offsetHeight;
	            style.top                   = elementStyle.top;
	            style.right                 = elementStyle.right;
	            style.bottom                = elementStyle.bottom;
	            style.left                  = elementStyle.left;
	            style.widthCSS              = elementStyle.width;
	            style.heightCSS             = elementStyle.height;
	            return style;
	        }

	        function storeStartSize() {
	            var style = getStyle();
	            getState(element).startSize = {
	                width: style.width,
	                height: style.height
	            };
	            debug("Element start size", getState(element).startSize);
	        }

	        function initListeners() {
	            getState(element).listeners = [];
	        }

	        function storeStyle() {
	            debug("storeStyle invoked.");
	            if (!getState(element)) {
	                debug("Aborting because element has been uninstalled");
	                return;
	            }

	            var style = getStyle();
	            getState(element).style = style;
	        }

	        function storeCurrentSize(element, width, height) {
	            getState(element).lastWidth = width;
	            getState(element).lastHeight  = height;
	        }

	        function getExpandChildElement(element) {
	            return getExpandElement(element).childNodes[0];
	        }

	        function getWidthOffset() {
	            return 2 * scrollbarSizes.width + 1;
	        }

	        function getHeightOffset() {
	            return 2 * scrollbarSizes.height + 1;
	        }

	        function getExpandWidth(width) {
	            return width + 10 + getWidthOffset();
	        }

	        function getExpandHeight(height) {
	            return height + 10 + getHeightOffset();
	        }

	        function getShrinkWidth(width) {
	            return width * 2 + getWidthOffset();
	        }

	        function getShrinkHeight(height) {
	            return height * 2 + getHeightOffset();
	        }

	        function positionScrollbars(element, width, height) {
	            var expand          = getExpandElement(element);
	            var shrink          = getShrinkElement(element);
	            var expandWidth     = getExpandWidth(width);
	            var expandHeight    = getExpandHeight(height);
	            var shrinkWidth     = getShrinkWidth(width);
	            var shrinkHeight    = getShrinkHeight(height);
	            expand.scrollLeft   = expandWidth;
	            expand.scrollTop    = expandHeight;
	            shrink.scrollLeft   = shrinkWidth;
	            shrink.scrollTop    = shrinkHeight;
	        }

	        function injectContainerElement() {
	            var container = getState(element).container;

	            if (!container) {
	                container                   = document.createElement("div");
	                container.className         = detectionContainerClass;
	                container.style.cssText     = "visibility: hidden; display: inline; width: 0px; height: 0px; z-index: -1; overflow: hidden; margin: 0; padding: 0;";
	                getState(element).container = container;
	                addAnimationClass(container);
	                element.appendChild(container);

	                var onAnimationStart = function () {
	                    getState(element).onRendered && getState(element).onRendered();
	                };

	                addEvent(container, "animationstart", onAnimationStart);

	                // Store the event handler here so that they may be removed when uninstall is called.
	                // See uninstall function for an explanation why it is needed.
	                getState(element).onAnimationStart = onAnimationStart;
	            }

	            return container;
	        }

	        function injectScrollElements() {
	            function alterPositionStyles() {
	                var style = getState(element).style;

	                if(style.position === "static") {
	                    element.style.position = "relative";

	                    var removeRelativeStyles = function(reporter, element, style, property) {
	                        function getNumericalValue(value) {
	                            return value.replace(/[^-\d\.]/g, "");
	                        }

	                        var value = style[property];

	                        if(value !== "auto" && getNumericalValue(value) !== "0") {
	                            reporter.warn("An element that is positioned static has style." + property + "=" + value + " which is ignored due to the static positioning. The element will need to be positioned relative, so the style." + property + " will be set to 0. Element: ", element);
	                            element.style[property] = 0;
	                        }
	                    };

	                    //Check so that there are no accidental styles that will make the element styled differently now that is is relative.
	                    //If there are any, set them to 0 (this should be okay with the user since the style properties did nothing before [since the element was positioned static] anyway).
	                    removeRelativeStyles(reporter, element, style, "top");
	                    removeRelativeStyles(reporter, element, style, "right");
	                    removeRelativeStyles(reporter, element, style, "bottom");
	                    removeRelativeStyles(reporter, element, style, "left");
	                }
	            }

	            function getLeftTopBottomRightCssText(left, top, bottom, right) {
	                left = (!left ? "0" : (left + "px"));
	                top = (!top ? "0" : (top + "px"));
	                bottom = (!bottom ? "0" : (bottom + "px"));
	                right = (!right ? "0" : (right + "px"));

	                return "left: " + left + "; top: " + top + "; right: " + right + "; bottom: " + bottom + ";";
	            }

	            debug("Injecting elements");

	            if (!getState(element)) {
	                debug("Aborting because element has been uninstalled");
	                return;
	            }

	            alterPositionStyles();

	            var rootContainer = getState(element).container;

	            if (!rootContainer) {
	                rootContainer = injectContainerElement();
	            }

	            // Due to this WebKit bug https://bugs.webkit.org/show_bug.cgi?id=80808 (currently fixed in Blink, but still present in WebKit browsers such as Safari),
	            // we need to inject two containers, one that is width/height 100% and another that is left/top -1px so that the final container always is 1x1 pixels bigger than
	            // the targeted element.
	            // When the bug is resolved, "containerContainer" may be removed.

	            // The outer container can occasionally be less wide than the targeted when inside inline elements element in WebKit (see https://bugs.webkit.org/show_bug.cgi?id=152980).
	            // This should be no problem since the inner container either way makes sure the injected scroll elements are at least 1x1 px.

	            var scrollbarWidth          = scrollbarSizes.width;
	            var scrollbarHeight         = scrollbarSizes.height;
	            var containerContainerStyle = "position: absolute; overflow: hidden; z-index: -1; visibility: hidden; width: 100%; height: 100%; left: 0px; top: 0px;";
	            var containerStyle          = "position: absolute; overflow: hidden; z-index: -1; visibility: hidden; " + getLeftTopBottomRightCssText(-(1 + scrollbarWidth), -(1 + scrollbarHeight), -scrollbarHeight, -scrollbarWidth);
	            var expandStyle             = "position: absolute; overflow: scroll; z-index: -1; visibility: hidden; width: 100%; height: 100%;";
	            var shrinkStyle             = "position: absolute; overflow: scroll; z-index: -1; visibility: hidden; width: 100%; height: 100%;";
	            var expandChildStyle        = "position: absolute; left: 0; top: 0;";
	            var shrinkChildStyle        = "position: absolute; width: 200%; height: 200%;";

	            var containerContainer      = document.createElement("div");
	            var container               = document.createElement("div");
	            var expand                  = document.createElement("div");
	            var expandChild             = document.createElement("div");
	            var shrink                  = document.createElement("div");
	            var shrinkChild             = document.createElement("div");

	            // Some browsers choke on the resize system being rtl, so force it to ltr. https://github.com/wnr/element-resize-detector/issues/56
	            // However, dir should not be set on the top level container as it alters the dimensions of the target element in some browsers.
	            containerContainer.dir              = "ltr";

	            containerContainer.style.cssText    = containerContainerStyle;
	            containerContainer.className        = detectionContainerClass;
	            container.className                 = detectionContainerClass;
	            container.style.cssText             = containerStyle;
	            expand.style.cssText                = expandStyle;
	            expandChild.style.cssText           = expandChildStyle;
	            shrink.style.cssText                = shrinkStyle;
	            shrinkChild.style.cssText           = shrinkChildStyle;

	            expand.appendChild(expandChild);
	            shrink.appendChild(shrinkChild);
	            container.appendChild(expand);
	            container.appendChild(shrink);
	            containerContainer.appendChild(container);
	            rootContainer.appendChild(containerContainer);

	            function onExpandScroll() {
	                getState(element).onExpand && getState(element).onExpand();
	            }

	            function onShrinkScroll() {
	                getState(element).onShrink && getState(element).onShrink();
	            }

	            addEvent(expand, "scroll", onExpandScroll);
	            addEvent(shrink, "scroll", onShrinkScroll);

	            // Store the event handlers here so that they may be removed when uninstall is called.
	            // See uninstall function for an explanation why it is needed.
	            getState(element).onExpandScroll = onExpandScroll;
	            getState(element).onShrinkScroll = onShrinkScroll;
	        }

	        function registerListenersAndPositionElements() {
	            function updateChildSizes(element, width, height) {
	                var expandChild             = getExpandChildElement(element);
	                var expandWidth             = getExpandWidth(width);
	                var expandHeight            = getExpandHeight(height);
	                expandChild.style.width     = expandWidth + "px";
	                expandChild.style.height    = expandHeight + "px";
	            }

	            function updateDetectorElements(done) {
	                var width           = element.offsetWidth;
	                var height          = element.offsetHeight;

	                debug("Storing current size", width, height);

	                // Store the size of the element sync here, so that multiple scroll events may be ignored in the event listeners.
	                // Otherwise the if-check in handleScroll is useless.
	                storeCurrentSize(element, width, height);

	                // Since we delay the processing of the batch, there is a risk that uninstall has been called before the batch gets to execute.
	                // Since there is no way to cancel the fn executions, we need to add an uninstall guard to all fns of the batch.

	                batchProcessor.add(0, function performUpdateChildSizes() {
	                    if (!getState(element)) {
	                        debug("Aborting because element has been uninstalled");
	                        return;
	                    }

	                    if (options.debug) {
	                        var w = element.offsetWidth;
	                        var h = element.offsetHeight;

	                        if (w !== width || h !== height) {
	                            reporter.warn(idHandler.get(element), "Scroll: Size changed before updating detector elements.");
	                        }
	                    }

	                    updateChildSizes(element, width, height);
	                });

	                batchProcessor.add(1, function updateScrollbars() {
	                    if (!getState(element)) {
	                        debug("Aborting because element has been uninstalled");
	                        return;
	                    }

	                    positionScrollbars(element, width, height);
	                });

	                if (done) {
	                    batchProcessor.add(2, function () {
	                        if (!getState(element)) {
	                            debug("Aborting because element has been uninstalled");
	                            return;
	                        }

	                        done();
	                    });
	                }
	            }

	            function areElementsInjected() {
	                return !!getState(element).container;
	            }

	            function notifyListenersIfNeeded() {
	                function isFirstNotify() {
	                    return getState(element).lastNotifiedWidth === undefined;
	                }

	                debug("notifyListenersIfNeeded invoked");

	                var state = getState(element);

	                // Don't notify the if the current size is the start size, and this is the first notification.
	                if (isFirstNotify() && state.lastWidth === state.startSize.width && state.lastHeight === state.startSize.height) {
	                    return debug("Not notifying: Size is the same as the start size, and there has been no notification yet.");
	                }

	                // Don't notify if the size already has been notified.
	                if (state.lastWidth === state.lastNotifiedWidth && state.lastHeight === state.lastNotifiedHeight) {
	                    return debug("Not notifying: Size already notified");
	                }


	                debug("Current size not notified, notifying...");
	                state.lastNotifiedWidth = state.lastWidth;
	                state.lastNotifiedHeight = state.lastHeight;
	                forEach(getState(element).listeners, function (listener) {
	                    listener(element);
	                });
	            }

	            function handleRender() {
	                debug("startanimation triggered.");

	                if (isUnrendered(element)) {
	                    debug("Ignoring since element is still unrendered...");
	                    return;
	                }

	                debug("Element rendered.");
	                var expand = getExpandElement(element);
	                var shrink = getShrinkElement(element);
	                if (expand.scrollLeft === 0 || expand.scrollTop === 0 || shrink.scrollLeft === 0 || shrink.scrollTop === 0) {
	                    debug("Scrollbars out of sync. Updating detector elements...");
	                    updateDetectorElements(notifyListenersIfNeeded);
	                }
	            }

	            function handleScroll() {
	                debug("Scroll detected.");

	                if (isUnrendered(element)) {
	                    // Element is still unrendered. Skip this scroll event.
	                    debug("Scroll event fired while unrendered. Ignoring...");
	                    return;
	                }

	                var width = element.offsetWidth;
	                var height = element.offsetHeight;

	                if (width !== element.lastWidth || height !== element.lastHeight) {
	                    debug("Element size changed.");
	                    updateDetectorElements(notifyListenersIfNeeded);
	                } else {
	                    debug("Element size has not changed (" + width + "x" + height + ").");
	                }
	            }

	            debug("registerListenersAndPositionElements invoked.");

	            if (!getState(element)) {
	                debug("Aborting because element has been uninstalled");
	                return;
	            }

	            getState(element).onRendered = handleRender;
	            getState(element).onExpand = handleScroll;
	            getState(element).onShrink = handleScroll;

	            var style = getState(element).style;
	            updateChildSizes(element, style.width, style.height);
	        }

	        function finalizeDomMutation() {
	            debug("finalizeDomMutation invoked.");

	            if (!getState(element)) {
	                debug("Aborting because element has been uninstalled");
	                return;
	            }

	            var style = getState(element).style;
	            storeCurrentSize(element, style.width, style.height);
	            positionScrollbars(element, style.width, style.height);
	        }

	        function ready() {
	            callback(element);
	        }

	        function install() {
	            debug("Installing...");
	            initListeners();
	            storeStartSize();

	            batchProcessor.add(0, storeStyle);
	            batchProcessor.add(1, injectScrollElements);
	            batchProcessor.add(2, registerListenersAndPositionElements);
	            batchProcessor.add(3, finalizeDomMutation);
	            batchProcessor.add(4, ready);
	        }

	        debug("Making detectable...");

	        if (isDetached(element)) {
	            debug("Element is detached");

	            injectContainerElement();

	            debug("Waiting until element is attached...");

	            getState(element).onRendered = function () {
	                debug("Element is now attached");
	                install();
	            };
	        } else {
	            install();
	        }
	    }

	    function uninstall(element) {
	        var state = getState(element);

	        if (!state) {
	            // Uninstall has been called on a non-erd element.
	            return;
	        }

	        // Uninstall may have been called in the following scenarios:
	        // (1) Right between the sync code and async batch (here state.busy = true, but nothing have been registered or injected).
	        // (2) In the ready callback of the last level of the batch by another element (here, state.busy = true, but all the stuff has been injected).
	        // (3) After the installation process (here, state.busy = false and all the stuff has been injected).
	        // So to be on the safe side, let's check for each thing before removing.

	        // We need to remove the event listeners, because otherwise the event might fire on an uninstall element which results in an error when trying to get the state of the element.
	        state.onExpandScroll && removeEvent(getExpandElement(element), "scroll", state.onExpandScroll);
	        state.onShrinkScroll && removeEvent(getShrinkElement(element), "scroll", state.onShrinkScroll);
	        state.onAnimationStart && removeEvent(state.container, "animationstart", state.onAnimationStart);

	        state.container && element.removeChild(state.container);
	    }

	    return {
	        makeDetectable: makeDetectable,
	        addListener: addListener,
	        uninstall: uninstall
	    };
	};


/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	var forEach                 = __webpack_require__(5).forEach;
	var elementUtilsMaker       = __webpack_require__(21);
	var listenerHandlerMaker    = __webpack_require__(24);
	var idGeneratorMaker        = __webpack_require__(22);
	var idHandlerMaker          = __webpack_require__(23);
	var reporterMaker           = __webpack_require__(25);
	var browserDetector         = __webpack_require__(4);
	var batchProcessorMaker     = __webpack_require__(14);
	var stateHandler            = __webpack_require__(26);

	//Detection strategies.
	var objectStrategyMaker     = __webpack_require__(18);
	var scrollStrategyMaker     = __webpack_require__(19);

	function isCollection(obj) {
	    return Array.isArray(obj) || obj.length !== undefined;
	}

	function toArray(collection) {
	    if (!Array.isArray(collection)) {
	        var array = [];
	        forEach(collection, function (obj) {
	            array.push(obj);
	        });
	        return array;
	    } else {
	        return collection;
	    }
	}

	function isElement(obj) {
	    return obj && obj.nodeType === 1;
	}

	/**
	 * @typedef idHandler
	 * @type {object}
	 * @property {function} get Gets the resize detector id of the element.
	 * @property {function} set Generate and sets the resize detector id of the element.
	 */

	/**
	 * @typedef Options
	 * @type {object}
	 * @property {boolean} callOnAdd    Determines if listeners should be called when they are getting added.
	                                    Default is true. If true, the listener is guaranteed to be called when it has been added.
	                                    If false, the listener will not be guarenteed to be called when it has been added (does not prevent it from being called).
	 * @property {idHandler} idHandler  A custom id handler that is responsible for generating, setting and retrieving id's for elements.
	                                    If not provided, a default id handler will be used.
	 * @property {reporter} reporter    A custom reporter that handles reporting logs, warnings and errors.
	                                    If not provided, a default id handler will be used.
	                                    If set to false, then nothing will be reported.
	 * @property {boolean} debug        If set to true, the the system will report debug messages as default for the listenTo method.
	 */

	/**
	 * Creates an element resize detector instance.
	 * @public
	 * @param {Options?} options Optional global options object that will decide how this instance will work.
	 */
	module.exports = function(options) {
	    options = options || {};

	    //idHandler is currently not an option to the listenTo function, so it should not be added to globalOptions.
	    var idHandler;

	    if (options.idHandler) {
	        // To maintain compatability with idHandler.get(element, readonly), make sure to wrap the given idHandler
	        // so that readonly flag always is true when it's used here. This may be removed next major version bump.
	        idHandler = {
	            get: function (element) { return options.idHandler.get(element, true); },
	            set: options.idHandler.set
	        };
	    } else {
	        var idGenerator = idGeneratorMaker();
	        var defaultIdHandler = idHandlerMaker({
	            idGenerator: idGenerator,
	            stateHandler: stateHandler
	        });
	        idHandler = defaultIdHandler;
	    }

	    //reporter is currently not an option to the listenTo function, so it should not be added to globalOptions.
	    var reporter = options.reporter;

	    if(!reporter) {
	        //If options.reporter is false, then the reporter should be quiet.
	        var quiet = reporter === false;
	        reporter = reporterMaker(quiet);
	    }

	    //batchProcessor is currently not an option to the listenTo function, so it should not be added to globalOptions.
	    var batchProcessor = getOption(options, "batchProcessor", batchProcessorMaker({ reporter: reporter }));

	    //Options to be used as default for the listenTo function.
	    var globalOptions = {};
	    globalOptions.callOnAdd     = !!getOption(options, "callOnAdd", true);
	    globalOptions.debug         = !!getOption(options, "debug", false);

	    var eventListenerHandler    = listenerHandlerMaker(idHandler);
	    var elementUtils            = elementUtilsMaker({
	        stateHandler: stateHandler
	    });

	    //The detection strategy to be used.
	    var detectionStrategy;
	    var desiredStrategy = getOption(options, "strategy", "object");
	    var strategyOptions = {
	        reporter: reporter,
	        batchProcessor: batchProcessor,
	        stateHandler: stateHandler,
	        idHandler: idHandler
	    };

	    if(desiredStrategy === "scroll") {
	        if (browserDetector.isLegacyOpera()) {
	            reporter.warn("Scroll strategy is not supported on legacy Opera. Changing to object strategy.");
	            desiredStrategy = "object";
	        } else if (browserDetector.isIE(9)) {
	            reporter.warn("Scroll strategy is not supported on IE9. Changing to object strategy.");
	            desiredStrategy = "object";
	        }
	    }

	    if(desiredStrategy === "scroll") {
	        detectionStrategy = scrollStrategyMaker(strategyOptions);
	    } else if(desiredStrategy === "object") {
	        detectionStrategy = objectStrategyMaker(strategyOptions);
	    } else {
	        throw new Error("Invalid strategy name: " + desiredStrategy);
	    }

	    //Calls can be made to listenTo with elements that are still being installed.
	    //Also, same elements can occur in the elements list in the listenTo function.
	    //With this map, the ready callbacks can be synchronized between the calls
	    //so that the ready callback can always be called when an element is ready - even if
	    //it wasn't installed from the function itself.
	    var onReadyCallbacks = {};

	    /**
	     * Makes the given elements resize-detectable and starts listening to resize events on the elements. Calls the event callback for each event for each element.
	     * @public
	     * @param {Options?} options Optional options object. These options will override the global options. Some options may not be overriden, such as idHandler.
	     * @param {element[]|element} elements The given array of elements to detect resize events of. Single element is also valid.
	     * @param {function} listener The callback to be executed for each resize event for each element.
	     */
	    function listenTo(options, elements, listener) {
	        function onResizeCallback(element) {
	            var listeners = eventListenerHandler.get(element);
	            forEach(listeners, function callListenerProxy(listener) {
	                listener(element);
	            });
	        }

	        function addListener(callOnAdd, element, listener) {
	            eventListenerHandler.add(element, listener);

	            if(callOnAdd) {
	                listener(element);
	            }
	        }

	        //Options object may be omitted.
	        if(!listener) {
	            listener = elements;
	            elements = options;
	            options = {};
	        }

	        if(!elements) {
	            throw new Error("At least one element required.");
	        }

	        if(!listener) {
	            throw new Error("Listener required.");
	        }

	        if (isElement(elements)) {
	            // A single element has been passed in.
	            elements = [elements];
	        } else if (isCollection(elements)) {
	            // Convert collection to array for plugins.
	            // TODO: May want to check so that all the elements in the collection are valid elements.
	            elements = toArray(elements);
	        } else {
	            return reporter.error("Invalid arguments. Must be a DOM element or a collection of DOM elements.");
	        }

	        var elementsReady = 0;

	        var callOnAdd = getOption(options, "callOnAdd", globalOptions.callOnAdd);
	        var onReadyCallback = getOption(options, "onReady", function noop() {});
	        var debug = getOption(options, "debug", globalOptions.debug);

	        forEach(elements, function attachListenerToElement(element) {
	            if (!stateHandler.getState(element)) {
	                stateHandler.initState(element);
	                idHandler.set(element);
	            }

	            var id = idHandler.get(element);

	            debug && reporter.log("Attaching listener to element", id, element);

	            if(!elementUtils.isDetectable(element)) {
	                debug && reporter.log(id, "Not detectable.");
	                if(elementUtils.isBusy(element)) {
	                    debug && reporter.log(id, "System busy making it detectable");

	                    //The element is being prepared to be detectable. Do not make it detectable.
	                    //Just add the listener, because the element will soon be detectable.
	                    addListener(callOnAdd, element, listener);
	                    onReadyCallbacks[id] = onReadyCallbacks[id] || [];
	                    onReadyCallbacks[id].push(function onReady() {
	                        elementsReady++;

	                        if(elementsReady === elements.length) {
	                            onReadyCallback();
	                        }
	                    });
	                    return;
	                }

	                debug && reporter.log(id, "Making detectable...");
	                //The element is not prepared to be detectable, so do prepare it and add a listener to it.
	                elementUtils.markBusy(element, true);
	                return detectionStrategy.makeDetectable({ debug: debug }, element, function onElementDetectable(element) {
	                    debug && reporter.log(id, "onElementDetectable");

	                    if (stateHandler.getState(element)) {
	                        elementUtils.markAsDetectable(element);
	                        elementUtils.markBusy(element, false);
	                        detectionStrategy.addListener(element, onResizeCallback);
	                        addListener(callOnAdd, element, listener);

	                        // Since the element size might have changed since the call to "listenTo", we need to check for this change,
	                        // so that a resize event may be emitted.
	                        // Having the startSize object is optional (since it does not make sense in some cases such as unrendered elements), so check for its existance before.
	                        // Also, check the state existance before since the element may have been uninstalled in the installation process.
	                        var state = stateHandler.getState(element);
	                        if (state && state.startSize) {
	                            var width = element.offsetWidth;
	                            var height = element.offsetHeight;
	                            if (state.startSize.width !== width || state.startSize.height !== height) {
	                                onResizeCallback(element);
	                            }
	                        }

	                        if(onReadyCallbacks[id]) {
	                            forEach(onReadyCallbacks[id], function(callback) {
	                                callback();
	                            });
	                        }
	                    } else {
	                        // The element has been unisntalled before being detectable.
	                        debug && reporter.log(id, "Element uninstalled before being detectable.");
	                    }

	                    delete onReadyCallbacks[id];

	                    elementsReady++;
	                    if(elementsReady === elements.length) {
	                        onReadyCallback();
	                    }
	                });
	            }

	            debug && reporter.log(id, "Already detecable, adding listener.");

	            //The element has been prepared to be detectable and is ready to be listened to.
	            addListener(callOnAdd, element, listener);
	            elementsReady++;
	        });

	        if(elementsReady === elements.length) {
	            onReadyCallback();
	        }
	    }

	    function uninstall(elements) {
	        if(!elements) {
	            return reporter.error("At least one element is required.");
	        }

	        if (isElement(elements)) {
	            // A single element has been passed in.
	            elements = [elements];
	        } else if (isCollection(elements)) {
	            // Convert collection to array for plugins.
	            // TODO: May want to check so that all the elements in the collection are valid elements.
	            elements = toArray(elements);
	        } else {
	            return reporter.error("Invalid arguments. Must be a DOM element or a collection of DOM elements.");
	        }

	        forEach(elements, function (element) {
	            eventListenerHandler.removeAllListeners(element);
	            detectionStrategy.uninstall(element);
	            stateHandler.cleanState(element);
	        });
	    }

	    return {
	        listenTo: listenTo,
	        removeListener: eventListenerHandler.removeListener,
	        removeAllListeners: eventListenerHandler.removeAllListeners,
	        uninstall: uninstall
	    };
	};

	function getOption(options, name, defaultValue) {
	    var value = options[name];

	    if((value === undefined || value === null) && defaultValue !== undefined) {
	        return defaultValue;
	    }

	    return value;
	}


/***/ },
/* 21 */
/***/ function(module, exports) {

	"use strict";

	module.exports = function(options) {
	    var getState = options.stateHandler.getState;

	    /**
	     * Tells if the element has been made detectable and ready to be listened for resize events.
	     * @public
	     * @param {element} The element to check.
	     * @returns {boolean} True or false depending on if the element is detectable or not.
	     */
	    function isDetectable(element) {
	        var state = getState(element);
	        return state && !!state.isDetectable;
	    }

	    /**
	     * Marks the element that it has been made detectable and ready to be listened for resize events.
	     * @public
	     * @param {element} The element to mark.
	     */
	    function markAsDetectable(element) {
	        getState(element).isDetectable = true;
	    }

	    /**
	     * Tells if the element is busy or not.
	     * @public
	     * @param {element} The element to check.
	     * @returns {boolean} True or false depending on if the element is busy or not.
	     */
	    function isBusy(element) {
	        return !!getState(element).busy;
	    }

	    /**
	     * Marks the object is busy and should not be made detectable.
	     * @public
	     * @param {element} element The element to mark.
	     * @param {boolean} busy If the element is busy or not.
	     */
	    function markBusy(element, busy) {
	        getState(element).busy = !!busy;
	    }

	    return {
	        isDetectable: isDetectable,
	        markAsDetectable: markAsDetectable,
	        isBusy: isBusy,
	        markBusy: markBusy
	    };
	};


/***/ },
/* 22 */
/***/ function(module, exports) {

	"use strict";

	module.exports = function() {
	    var idCount = 1;

	    /**
	     * Generates a new unique id in the context.
	     * @public
	     * @returns {number} A unique id in the context.
	     */
	    function generate() {
	        return idCount++;
	    }

	    return {
	        generate: generate
	    };
	};


/***/ },
/* 23 */
/***/ function(module, exports) {

	"use strict";

	module.exports = function(options) {
	    var idGenerator     = options.idGenerator;
	    var getState        = options.stateHandler.getState;

	    /**
	     * Gets the resize detector id of the element.
	     * @public
	     * @param {element} element The target element to get the id of.
	     * @returns {string|number|null} The id of the element. Null if it has no id.
	     */
	    function getId(element) {
	        var state = getState(element);

	        if (state && state.id !== undefined) {
	            return state.id;
	        }

	        return null;
	    }

	    /**
	     * Sets the resize detector id of the element. Requires the element to have a resize detector state initialized.
	     * @public
	     * @param {element} element The target element to set the id of.
	     * @returns {string|number|null} The id of the element.
	     */
	    function setId(element) {
	        var state = getState(element);

	        if (!state) {
	            throw new Error("setId required the element to have a resize detection state.");
	        }

	        var id = idGenerator.generate();

	        state.id = id;

	        return id;
	    }

	    return {
	        get: getId,
	        set: setId
	    };
	};


/***/ },
/* 24 */
/***/ function(module, exports) {

	"use strict";

	module.exports = function(idHandler) {
	    var eventListeners = {};

	    /**
	     * Gets all listeners for the given element.
	     * @public
	     * @param {element} element The element to get all listeners for.
	     * @returns All listeners for the given element.
	     */
	    function getListeners(element) {
	        var id = idHandler.get(element);

	        if (id === undefined) {
	            return [];
	        }

	        return eventListeners[id] || [];
	    }

	    /**
	     * Stores the given listener for the given element. Will not actually add the listener to the element.
	     * @public
	     * @param {element} element The element that should have the listener added.
	     * @param {function} listener The callback that the element has added.
	     */
	    function addListener(element, listener) {
	        var id = idHandler.get(element);

	        if(!eventListeners[id]) {
	            eventListeners[id] = [];
	        }

	        eventListeners[id].push(listener);
	    }

	    function removeListener(element, listener) {
	        var listeners = getListeners(element);
	        for (var i = 0, len = listeners.length; i < len; ++i) {
	            if (listeners[i] === listener) {
	              listeners.splice(i, 1);
	              break;
	            }
	        }
	    }

	    function removeAllListeners(element) {
	      var listeners = getListeners(element);
	      if (!listeners) { return; }
	      listeners.length = 0;
	    }

	    return {
	        get: getListeners,
	        add: addListener,
	        removeListener: removeListener,
	        removeAllListeners: removeAllListeners
	    };
	};


/***/ },
/* 25 */
/***/ function(module, exports) {

	"use strict";

	/* global console: false */

	/**
	 * Reporter that handles the reporting of logs, warnings and errors.
	 * @public
	 * @param {boolean} quiet Tells if the reporter should be quiet or not.
	 */
	module.exports = function(quiet) {
	    function noop() {
	        //Does nothing.
	    }

	    var reporter = {
	        log: noop,
	        warn: noop,
	        error: noop
	    };

	    if(!quiet && window.console) {
	        var attachFunction = function(reporter, name) {
	            //The proxy is needed to be able to call the method with the console context,
	            //since we cannot use bind.
	            reporter[name] = function reporterProxy() {
	                var f = console[name];
	                if (f.apply) { //IE9 does not support console.log.apply :)
	                    f.apply(console, arguments);
	                } else {
	                    for (var i = 0; i < arguments.length; i++) {
	                        f(arguments[i]);
	                    }
	                }
	            };
	        };

	        attachFunction(reporter, "log");
	        attachFunction(reporter, "warn");
	        attachFunction(reporter, "error");
	    }

	    return reporter;
	};

/***/ },
/* 26 */
/***/ function(module, exports) {

	"use strict";

	var prop = "_erd";

	function initState(element) {
	    element[prop] = {};
	    return getState(element);
	}

	function getState(element) {
	    return element[prop];
	}

	function cleanState(element) {
	    delete element[prop];
	}

	module.exports = {
	    initState: initState,
	    getState: getState,
	    cleanState: cleanState
	};


/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
	  value: true
	});
	exports['default'] = getCloneDimensions;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _getMargin = __webpack_require__(6);

	var _getMargin2 = _interopRequireDefault(_getMargin);

	function getCloneDimensions(node, options) {
	  var parentNode = node.parentNode;

	  var context = document.createElement('div');
	  var clone = node.cloneNode(true);
	  var style = getComputedStyle(node);
	  var rect = undefined,
	      width = undefined,
	      height = undefined,
	      margin = undefined;

	  // give the node some context to measure off of
	  // no height and hidden overflow hide node copy
	  context.style.height = 0;
	  context.style.overflow = 'hidden';

	  // clean up any attributes that might cause a conflict with the original node
	  // i.e. inputs that should focus or submit data
	  clone.setAttribute('id', '');
	  clone.setAttribute('name', '');

	  // set props to get a true dimension calculation
	  if (options.display || style.getPropertyValue('display') === 'none') {
	    clone.style.display = options.display || 'block';
	  }
	  if (options.width || !parseInt(style.getPropertyValue('width'))) {
	    clone.style.width = options.width || 'auto';
	  }
	  if (options.height || !parseInt(style.getPropertyValue('height'))) {
	    clone.style.height = options.height || 'auto';
	  }

	  // append copy to context
	  context.appendChild(clone);

	  // append context to DOM so we can measure
	  parentNode.appendChild(context);

	  // get accurate dimensions
	  rect = clone.getBoundingClientRect();
	  width = clone.offsetWidth;
	  height = clone.offsetHeight;

	  // destroy clone
	  parentNode.removeChild(context);

	  return {
	    rect: {
	      width: width,
	      height: height,
	      top: rect.top,
	      right: rect.right,
	      bottom: rect.bottom,
	      left: rect.left
	    },
	    margin: (0, _getMargin2['default'])(style)
	  };
	}

	module.exports = exports['default'];

/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, '__esModule', {
	  value: true
	});
	exports['default'] = getNodeDimensions;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _getCloneDimensions = __webpack_require__(27);

	var _getCloneDimensions2 = _interopRequireDefault(_getCloneDimensions);

	var _getMargin = __webpack_require__(6);

	var _getMargin2 = _interopRequireDefault(_getMargin);

	function getNodeDimensions(node) {
	  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

	  var rect = node.getBoundingClientRect();
	  var width = undefined,
	      height = undefined,
	      margin = undefined;

	  // determine if we need to clone the element to get proper dimensions or not
	  if (!rect.width || !rect.height || options.clone) {
	    var cloneDimensions = (0, _getCloneDimensions2['default'])(node, options);
	    rect = cloneDimensions.rect;
	    margin = cloneDimensions.margin;
	  }
	  // if no cloning needed, we need to determine if margin should be accounted for
	  else if (options.margin) {
	      margin = (0, _getMargin2['default'])(getComputedStyle(node));
	    }

	  // include margin in width/height calculation if desired
	  if (options.margin) {
	    width = margin.left + rect.width + margin.right;
	    height = margin.top + rect.height + margin.bottom;
	  } else {
	    width = rect.width;
	    height = rect.height;
	  }

	  return {
	    width: width,
	    height: height,
	    top: rect.top,
	    right: rect.right,
	    bottom: rect.bottom,
	    left: rect.left
	  };
	}

	module.exports = exports['default'];

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	var _reactDom = __webpack_require__(33);

	var _reactDom2 = _interopRequireDefault(_reactDom);

	var _getNodeDimensions = __webpack_require__(28);

	var _getNodeDimensions2 = _interopRequireDefault(_getNodeDimensions);

	var _resizeDetector = __webpack_require__(30);

	var _resizeDetector2 = _interopRequireDefault(_resizeDetector);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var Measure = function (_Component) {
	  _inherits(Measure, _Component);

	  function Measure(props) {
	    _classCallCheck(this, Measure);

	    var _this = _possibleConstructorReturn(this, (Measure.__proto__ || Object.getPrototypeOf(Measure)).call(this, props));

	    _this.measure = function () {
	      var includeMargin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.includeMargin;
	      var useClone = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.useClone;

	      // bail out if we shouldn't measure
	      if (!_this.props.shouldMeasure) return;

	      // if no parent available we need to requery the DOM node
	      if (!_this._node.parentNode) {
	        _this._setDOMNode();
	      }

	      var dimensions = _this.getDimensions(_this._node, includeMargin, useClone);
	      var isChildFunction = typeof _this.props.children === 'function';

	      // determine if we need to update our callback with new dimensions or not
	      _this._propsToMeasure.some(function (prop) {
	        if (dimensions[prop] !== _this._lastDimensions[prop]) {
	          // update our callback if we've found a dimension that has changed
	          _this.props.onMeasure(dimensions);

	          // update state to send dimensions to child function
	          if (isChildFunction && typeof _this !== 'undefined') {
	            _this.setState({ dimensions: dimensions });
	          }

	          // store last dimensions to compare changes
	          _this._lastDimensions = dimensions;

	          // we don't need to look any further, bail out
	          return true;
	        }
	      });
	    };

	    _this.state = {
	      dimensions: {
	        width: 0,
	        height: 0,
	        top: 0,
	        right: 0,
	        bottom: 0,
	        left: 0
	      }
	    };
	    _this._node = null;
	    _this._propsToMeasure = _this._getPropsToMeasure(props);
	    _this._lastDimensions = {};
	    return _this;
	  }

	  _createClass(Measure, [{
	    key: 'componentDidMount',
	    value: function componentDidMount() {
	      var _this2 = this;

	      this._setDOMNode();

	      // measure on first render
	      this.measure();

	      // add component to resize detector to detect changes on resize
	      (0, _resizeDetector2.default)().listenTo(this._node, function () {
	        return _this2.measure();
	      });
	    }
	  }, {
	    key: 'componentWillReceiveProps',
	    value: function componentWillReceiveProps(_ref) {
	      var config = _ref.config;
	      var whitelist = _ref.whitelist;
	      var blacklist = _ref.blacklist;

	      // we store the properties ourselves so we need to update them if the
	      // whitelist or blacklist props have changed
	      if (this.props.whitelist !== whitelist || this.props.blacklist !== blacklist) {
	        this._propsToMeasure = this._getPropsToMeasure({ whitelist: whitelist, blacklist: blacklist });
	      }
	    }
	  }, {
	    key: 'componentWillUnmount',
	    value: function componentWillUnmount() {
	      (0, _resizeDetector2.default)().removeAllListeners(this._node);
	      (0, _resizeDetector2.default)().uninstall(this._node);
	      this._node = null;
	    }
	  }, {
	    key: '_setDOMNode',
	    value: function _setDOMNode() {
	      this._node = _reactDom2.default.findDOMNode(this);
	    }
	  }, {
	    key: 'getDimensions',
	    value: function getDimensions() {
	      var node = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this._node;
	      var includeMargin = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props.includeMargin;
	      var useClone = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.props.useClone;
	      var cloneOptions = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : this.props.cloneOptions;

	      return (0, _getNodeDimensions2.default)(node, _extends({
	        margin: includeMargin,
	        clone: useClone
	      }, cloneOptions));
	    }
	  }, {
	    key: '_getPropsToMeasure',
	    value: function _getPropsToMeasure(_ref2) {
	      var whitelist = _ref2.whitelist;
	      var blacklist = _ref2.blacklist;

	      return whitelist.filter(function (prop) {
	        return blacklist.indexOf(prop) < 0;
	      });
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      var children = this.props.children;

	      return _react.Children.only(typeof children === 'function' ? children(this.state.dimensions) : children);
	    }
	  }]);

	  return Measure;
	}(_react.Component);

	Measure.propTypes = {
	  whitelist: _react.PropTypes.array,
	  blacklist: _react.PropTypes.array,
	  includeMargin: _react.PropTypes.bool,
	  useClone: _react.PropTypes.bool,
	  cloneOptions: _react.PropTypes.object,
	  shouldMeasure: _react.PropTypes.bool,
	  onMeasure: _react.PropTypes.func
	};
	Measure.defaultProps = {
	  whitelist: ['width', 'height', 'top', 'right', 'bottom', 'left'],
	  blacklist: [],
	  includeMargin: true,
	  useClone: false,
	  cloneOptions: {},
	  shouldMeasure: true,
	  onMeasure: function onMeasure() {
	    return null;
	  }
	};
	exports.default = Measure;
	module.exports = exports['default'];

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = resizeDetector;

	var _elementResizeDetector = __webpack_require__(20);

	var _elementResizeDetector2 = _interopRequireDefault(_elementResizeDetector);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var instance = null;

	function resizeDetector() {
	  if (!instance) {
	    instance = (0, _elementResizeDetector2.default)({
	      strategy: 'scroll'
	    });
	  }
	  return instance;
	}
	module.exports = exports['default'];

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	// style-loader: Adds some css to the DOM by adding a <style> tag

	// load the styles
	var content = __webpack_require__(16);
	if(typeof content === 'string') content = [[module.id, content, '']];
	// add the styles to the DOM
	var update = __webpack_require__(8)(content, {});
	if(content.locals) module.exports = content.locals;
	// Hot Module Replacement
	if(false) {
		// When the styles change, update the <style> tags
		if(!content.locals) {
			module.hot.accept("!!./../node_modules/css-loader/index.js?modules&&localIdentName=__react-graph-editor__[name]__[local]__[hash:base64:5]!./graph.css", function() {
				var newContent = require("!!./../node_modules/css-loader/index.js?modules&&localIdentName=__react-graph-editor__[name]__[local]__[hash:base64:5]!./graph.css");
				if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
				update(newContent);
			});
		}
		// When the module is disposed, remove the <style> tags
		module.hot.dispose(function() { update(); });
	}

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	// style-loader: Adds some css to the DOM by adding a <style> tag

	// load the styles
	var content = __webpack_require__(17);
	if(typeof content === 'string') content = [[module.id, content, '']];
	// add the styles to the DOM
	var update = __webpack_require__(8)(content, {});
	if(content.locals) module.exports = content.locals;
	// Hot Module Replacement
	if(false) {
		// When the styles change, update the <style> tags
		if(!content.locals) {
			module.hot.accept("!!./../node_modules/css-loader/index.js?modules&&localIdentName=__react-graph-editor__[name]__[local]__[hash:base64:5]!./node.css", function() {
				var newContent = require("!!./../node_modules/css-loader/index.js?modules&&localIdentName=__react-graph-editor__[name]__[local]__[hash:base64:5]!./node.css");
				if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
				update(newContent);
			});
		}
		// When the module is disposed, remove the <style> tags
		module.hot.dispose(function() { update(); });
	}

/***/ },
/* 33 */
/***/ function(module, exports) {

	module.exports = ReactDOM;

/***/ }
/******/ ]);